SystemOrganization addCategory: #UndoRedo!
SystemOrganization addCategory: #'UndoRedo-test'!

TestCase subclass: #UndoRedoTest
	instanceVariableNames: 'u'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UndoRedo-test'!

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:37'!
setUp
	super setUp.
	u := UndoRedo new.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:37'!
testAdd
	u add: 1.
	self assert: u currentItem equals: 1.
	u add: 2.
	self assert: u currentItem equals: 2.
	u add: 3.
	self assert: u currentItem equals: 3.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:37'!
testAddAfterUndo
	u add: 1.
	u add: 2.
	u add: 3.

	u undo.
	u undo.
	u add: 4.
	self assert: u currentItem equals: 4.
	u undo.
	self assert: u currentItem equals: 1.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:38'!
testCanRedo
	self deny: u canRedo.
	u add: 1.
	self deny: u canRedo.
	u undo.
	self assert: u canRedo.
	u add: 1.
	self deny: u canRedo.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:40'!
testCanUndo
	self deny: u canUndo.
	u add: 1.
	self assert: u canUndo.
	u add: 2.
	self assert: u canUndo.
	u undo.
	self assert: u canUndo.
	u redo.
	self assert: u canUndo.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:37'!
testRedo
	u add: 1.
	u add: 2.
	u add: 3.
	u undo.
	u undo.
	
	u redo.
	self assert: u currentItem equals: 2.
	u redo.
	self assert: u currentItem equals: 3.! !

!UndoRedoTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/12/2013 17:37'!
testUndo
	u add: 1.
	u add: 2.
	u add: 3.

	u undo.
	self assert: u currentItem equals: 2.
	u undo.
	self assert: u currentItem equals: 1.
	u undo.
	! !

Object subclass: #UndoRedo
	instanceVariableNames: 'items position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UndoRedo'!

!UndoRedo methodsFor: 'adding' stamp: 'hjo 12/28/2011 15:43'!
add: anObject

	[self position < self items size] whileTrue: [self items removeLast].
	self items add: anObject.
	self position: self position +1.    ! !

!UndoRedo methodsFor: 'testing' stamp: 'hjo 12/28/2011 15:39'!
canRedo

	^self position < self items size.! !

!UndoRedo methodsFor: 'testing' stamp: 'hjo 12/28/2011 15:41'!
canUndo

	self items isEmpty ifTrue: [^false].
	self position = 0 ifTrue: [^false].
	^true.! !

!UndoRedo methodsFor: 'public' stamp: 'hjo 12/28/2011 15:42'!
currentItem

	^self position = 0 ifTrue: [nil] ifFalse: [self items at: self position].! !

!UndoRedo methodsFor: 'defaults' stamp: 'hjo 12/28/2011 15:32'!
defaultItems

	"Return a default object for instance variable items."
	^OrderedCollection new! !

!UndoRedo methodsFor: 'defaults' stamp: 'hjo 12/28/2011 15:33'!
defaultPosition

	"Return a default object for instance variable position."
	^0! !

!UndoRedo methodsFor: 'public' stamp: 'hjo 12/28/2011 15:39'!
doRedo

	self position: self position + 1! !

!UndoRedo methodsFor: 'public' stamp: 'hjo 12/28/2011 15:36'!
doUndo

	self position: self position -1    ! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:32'!
items

	^items setDefault: #defaultItems for: self withSetter: #items:! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
items: anOrderedCollection
		
	items := anOrderedCollection! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
position

	^position setDefault: #defaultPosition for: self withSetter: #position:! !

!UndoRedo methodsFor: 'accessing' stamp: 'hjo 12/28/2011 15:33'!
position: anInteger
		
	position := anInteger! !

!UndoRedo methodsFor: 'public' stamp: 'hjo 12/28/2011 15:38'!
redo

	self canRedo ifTrue: [self doRedo]! !

!UndoRedo methodsFor: 'public' stamp: 'hjo 12/28/2011 15:37'!
undo

	self canUndo ifTrue: [self doUndo]! !
